import java.awt.geom.Line2D;
import java.util.ArrayList;

/**
 * Die Klasse Kante repraesentiert Kanten in einem Graphen.
 * Sie stellt auch Methoden zur Verwaltung aller Kanten bereit.
 * 
 * @author (claus albowski) 
 * @version (dez 06)
 */
public class Kante
extends Line2D.Double
implements Comparable  // ermoeglicht das automatische Sortieren mit sort()
{
    // Klassenvariable
    private static ArrayList<Kante> kantenListe = new ArrayList<Kante>();
    private static int x=300;
    private static int y=300;
    // Klassenmethode
    public static void setzeDimension(int breite, int hoehe){ x=breite;y=hoehe; }
    private static void neueKante(Kante k){ kantenListe.add(k); }
    public static ArrayList<Kante> gibKanten(){ return kantenListe; }
    public static Kante gibKante(int i){ return kantenListe.get(i); }
    public static int gibAnzahl() { return kantenListe.size(); }
    
    /**
     * leert die Liste aller Kanten
     */
    public static void loescheKanten()
    {
        while (! kantenListe.isEmpty()) kantenListe.get(0).entferneKante();
    }
    
    /**
     * entfernt eine einzelne Kante aus der Liste aller Kanten
     */
    public static void loescheKante(Kante kante)
    {
        kantenListe.remove(kante);
    }
    
    // Fuer das Interface  Comparable notwendige Methode:
    public int compareTo(Object k) {
        if (laenge()<((Kante)k).laenge()) return -1;
        else if (laenge()>((Kante)k).laenge()) return 1;
        else return 0;
    }
    
    // Instanzvariable
    private Knoten von,nach;
    
    /**
     * Konstruktor fuer Objekte der Klasse Kante
     */
    public Kante(Knoten von, Knoten nach)
    {
        super(von, nach);
        this.von=von;
        this.nach=nach;
        von.neueKante(this);
        nach.neueKante(this);
        neueKante(this);
    }
    
    public Knoten gibVon() { return von; }
    public Knoten gibNach() { return nach; }
    
    /**
     * gibt zu einem Knoten zurueck, ob er zur Kante gehoert
     */
    public boolean istEinKnoten(Knoten p)
    {
        if (p.equals(gibVon())) return true;
        if (p.equals(gibNach())) return true;
        return false;
    }
    
    /**
     * entfernt diese Kante aus der Kantenliste.
     */
    public void entferneKante()
    {
        von.entferneKante(this);
        nach.entferneKante(this);
        kantenListe.remove(this);
    }

    /**
     * gibt den anderen Knoten der Kante zurueck.
     */
    public Knoten andererKnoten(Knoten p)
    {
        if (p.equals(von)) return nach;
        if (p.equals(nach)) return von;
        return null;
    }
    
    /**
     * gibt die Laenge der Kante  zurueck.
     */
    public double laenge(){
        return von.distance(nach);
    }
}
