import java.util.ArrayList;

/**
 * Die Klasse Teilbaum uebernimmt die Verwaltung der Teilbaeume
 * 
 * @author claus albowski
 * @version (maerz 2020)
 */
public class Teilbaum
{
    private ArrayList<Knoten> dieKnoten;
    private ArrayList<Kante> dieKanten;
    
    /**
     * Konstruktor fuer Teilbaeume beim Initialisieren
     */
    public Teilbaum(Knoten knoten)
    {
        dieKnoten = new ArrayList();
        dieKanten = new ArrayList();
        dieKnoten.add(knoten);
    }
    
    /**
     * Konstruktor fuer Teilbaeume beim Verbinden
     */
    public Teilbaum(Teilbaum tb1, Teilbaum tb2, Kante neueKante)
    {
        dieKnoten = new ArrayList();
        dieKanten = new ArrayList();
        for (Knoten knoten : tb1.gibKnoten())
        dieKnoten.add(knoten);
        for (Knoten knoten : tb2.gibKnoten())
        dieKnoten.add(knoten);
        for (Kante kante : tb1.gibKanten())
        dieKanten.add(kante);
        for (Kante kante : tb2.gibKanten())
        dieKanten.add(kante);
        dieKanten.add(neueKante);
    }
    
    public ArrayList<Knoten> gibKnoten() {return dieKnoten;}
    public ArrayList<Kante> gibKanten() {return dieKanten;}
    
    /**
     * verbindet zwei Teilbaeume zu einem, indem die Knoten und die Kanten
     * des zweiten in diesen uebernommen werden;
     * der zweite wird in Kruskal aus der Liste der Teilbaeume entfernt
     */
    public void verbinde(Teilbaum derAndere, Kante kante)
    {
        dieKnoten.addAll(derAndere.gibKnoten());
        dieKanten.addAll(derAndere.gibKanten());
        dieKanten.add(kante);
    }
    
    
//     /**
//      * nimmt eine neue Kante in den Teilgraphen auf
//      * [bei der ersten muessen beide Knoten aufgenommen werden]
//      */
//     public void neueKante(Kante kante)
//     {
//         dieKanten.add(kante);
//         if (!hatKnoten(kante.getP1())) dieKnoten.add(kante.getP1());
//         if (!hatKnoten(kante.getP2())) dieKnoten.add(kante.getP2());
//     }

    public boolean hatKante(Kante kante) { return dieKanten.contains(kante); }

    public boolean hatKnoten(Knoten knoten) { return dieKnoten.contains(knoten); }
}

